setup.py 9.52 KB
Newer Older
1
2
#!/usr/bin/env python

Christoph Groth's avatar
Christoph Groth committed
3
4
5
6
7
8
9
10
11
12
CONFIG_FILE = 'build.conf'
STATIC_VERSION_FILE = 'kwant/_static_version.py'
REQUIRED_CYTHON_VERSION = (0, 17, 1)
MUMPS_DEBIAN_PACKAGE = 'libmumps-scotch-dev'
NO_CYTHON_OPTION = '--no-cython'

import sys
import os
import subprocess
import ConfigParser
13
14
from distutils.core import setup
from distutils.extension import Extension
Christoph Groth's avatar
Christoph Groth committed
15
16
17
18
19
20
21
22
23
24
from distutils.errors import DistutilsError, CCompilerError
import numpy

try:
    import Cython
except:
    cython_version = ()
else:
    cython_version = tuple(
        int(n) for n in Cython.__version__.split('-')[0].split('.'))
25

Christoph Groth's avatar
Christoph Groth committed
26
27
28
29
30
31
32
try:
    sys.argv.remove(NO_CYTHON_OPTION)
    cythonize = False
except ValueError:
    cythonize = True

if cythonize and cython_version:
33
34
    from Cython.Distutils import build_ext
else:
Christoph Groth's avatar
Christoph Groth committed
35
36
37
38
39
40
41
42
43
44
45
    from distutils.command.build_ext import build_ext


class kwant_build_ext(build_ext):
    def run(self):
        try:
            build_ext.run(self)
        except (DistutilsError, CCompilerError):
            print >>sys.stderr, \
"""{0}
The compilation of kwant has failed.  Please examine the error message
Christoph Groth's avatar
Christoph Groth committed
46
above and consult the installation instructions in README.
Christoph Groth's avatar
Christoph Groth committed
47
48
49
50
51
52
53
54
55
You might have to customize {1}.
{0}
Build configuration was:
{2}
{0}""".format('*' * 70, CONFIG_FILE, build_summary)
            raise
        print '**************** Build summary ****************'
        print build_summary

56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83

# This is an exact copy of the function from kwant/version.py.  We can't import
# it here (because kwant is not yet built when this scipt is run), so we just
# include a copy.
def get_version_from_git():
    kwant_dir = os.path.dirname(os.path.abspath(__file__))
    try:
        p = subprocess.Popen(['git', 'describe'], cwd=kwant_dir,
                             stdout=subprocess.PIPE, stderr=subprocess.PIPE)
    except OSError:
        return

    if p.wait() != 0:
        return
    version = p.communicate()[0].strip()

    if version[0] == 'v':
        version = version[1:]

    try:
        p = subprocess.Popen(['git', 'diff', '--quiet'], cwd=kwant_dir)
    except OSError:
        version += '-confused'  # This should never happen.
    else:
        if p.wait() == 1:
            version += '-dirty'
    return version

Christoph Groth's avatar
Christoph Groth committed
84

85
def get_static_version():
Christoph Groth's avatar
Christoph Groth committed
86
    """Return the version as recorded inside kwant."""
87
    try:
Christoph Groth's avatar
Christoph Groth committed
88
        with open(STATIC_VERSION_FILE) as f:
89
90
91
92
93
94
95
            contents = f.read()
            assert contents[:11] == "version = '"
            assert contents[-2:] == "'\n"
            return contents[11:-2]
    except:
        return None

Christoph Groth's avatar
Christoph Groth committed
96
97
98
99
100
101
102
103
104
105
106
107
108
109
110
111
112
113
114
115
116
117
118
119
120
121
122
123
124
125
126
127
128
129
130
131
132
133
134
135
136
137
138
139
140
141
142
143
144
145
146
147
148
149
150
151
152
153
154
155
156
157
158
159
160
161
162
163
164
165
166
167
168
169
170
171
172
173
174
175
176
177
178
179
180
181
182
183
184
185
186
187
188
189
190
191
192
193
194
195
196
197
198
199
200
201
202
203
204
205
206
207
208
209
210
211
212
213
214
215
216
217
218
219
220
221

def version():
    """Determine the version of kwant.  Return it and save it in a file."""
    git_version = get_version_from_git()
    static_version = get_static_version()
    if git_version is not None:
        version = git_version
        if static_version != git_version:
            with open(STATIC_VERSION_FILE, 'w') as f:
                f.write("version = '%s'\n" % version)
    elif static_version is not None:
        version = static_version
    else:
        version = 'unknown'
    return version


def debian_mumps():
    """Return the configuration for debian-provided MUMPS if it is available,
    or an empty dictionary otherwise."""
    try:
        p = subprocess.Popen(
            ['dpkg-query', '-W', '-f=${Status}', MUMPS_DEBIAN_PACKAGE],
            stdout=subprocess.PIPE)
    except OSError:
        pass
    else:
        if p.wait() == 0 and p.communicate()[0] == 'install ok installed':
            return {'libraries': ['zmumps_scotch', 'mumps_common_scotch',
                                  'pord', 'mpiseq_scotch', 'gfortran']}
    return {}


def extensions():
    """Return a list of tuples (args, kwrds) to be passed to
    Extension. possibly after replacing ".pyx" with ".c" if Cython is not to be
    used."""

    global build_summary
    build_summary = []

    #### Add components of kwant without external compile-time dependencies.
    result = [
        (['kwant._system', ['kwant/_system.pyx']],
         {'include_dirs': ['kwant/graph']}),
        (['kwant.graph.core', ['kwant/graph/core.pyx']],
         {'depends': ['kwant/graph/core.pxd', 'kwant/graph/defs.h',
                      'kwant/graph/defs.pxd']}),
        (['kwant.graph.utils', ['kwant/graph/utils.pyx']],
         {'depends': ['kwant/graph/defs.h', 'kwant/graph/defs.pxd',
                      'kwant/graph/core.pxd']}),
        (['kwant.graph.slicer', ['kwant/graph/slicer.pyx',
                                 'kwant/graph/c_slicer/partitioner.cc',
                                 'kwant/graph/c_slicer/slicer.cc']],
         {'depends': ['kwant/graph/defs.h', 'kwant/graph/defs.pxd',
                      'kwant/graph/core.pxd',
                      'kwant/graph/c_slicer.pxd',
                      'kwant/graph/c_slicer/bucket_list.h',
                      'kwant/graph/c_slicer/graphwrap.h',
                      'kwant/graph/c_slicer/partitioner.h',
                      'kwant/graph/c_slicer/slicer.h']})]

    #### Add components of kwant with external compile-time dependencies.
    config = ConfigParser.ConfigParser()
    try:
        with open(CONFIG_FILE) as f:
            config.readfp(f)
    except IOError:
        with open(CONFIG_FILE, 'w') as f:
            f.write('# Created by setup.py - feel free to modify.\n')

    kwrds_by_section = {}
    for section in config.sections():
        kwrds_by_section[section] = kwrds = {}
        for name, value in config.items(section):
            kwrds[name] = value.split()

    # Setup LAPACK.
    lapack = kwrds_by_section.get('lapack')
    if lapack:
        build_summary.append('User-configured LAPACK and BLAS')
    else:
        lapack = {'libraries': ['lapack', 'blas']}
        build_summary.append('Default LAPACK and BLAS')
    kwrds = lapack.copy()
    kwrds.setdefault('depends', []).extend(
        [CONFIG_FILE, 'kwant/linalg/f_lapack.pxd'])
    result.append((['kwant.linalg.lapack', ['kwant/linalg/lapack.pyx']],
                   kwrds))

    # Setup MUMPS.
    kwrds = kwrds_by_section.get('mumps')
    if kwrds:
        build_summary.append('User-configured MUMPS')
    else:
        kwrds = debian_mumps()
        if kwrds:
            build_summary.append(
                'MUMPS from package {0}'.format(MUMPS_DEBIAN_PACKAGE))
    if kwrds:
        for name, value in lapack.iteritems():
            kwrds.setdefault(name, []).extend(value)
        kwrds.setdefault('depends', []).extend(
            [CONFIG_FILE, 'kwant/linalg/cmumps.pxd'])
        result.append((['kwant.linalg._mumps', ['kwant/linalg/_mumps.pyx']],
                       kwrds))
    else:
        build_summary.append('No MUMPS support')

    build_summary = '\n'.join(build_summary)
    return result


def ext_modules(extensions):
    """Prepare the ext_modules argument for distutils' setup."""
    result = []
    for args, kwrds in extensions:
        if not cythonize or not cython_version:
            if 'language' in kwrds:
                if kwrds['language'] == 'c':
                    ext = '.c'
                elif kwrds['language'] == 'c++':
                    ext = '.cpp'
                else:
                    print >>sys.stderr, 'Unknown language'
                    exit(1)
222
            else:
Christoph Groth's avatar
Christoph Groth committed
223
224
225
226
227
228
229
230
231
232
233
234
235
236
237
238
239
240
241
242
243
244
245
246
                ext = '.c'
            pyx_files = []
            cythonized_files = []
            sources = []
            for f in args[1]:
                if f[-4:] == '.pyx':
                    pyx_files.append(f)
                    f = f[:-4] + ext
                    cythonized_files.append(f)
                sources.append(f)
            args[1] = sources

            try:
                cythonized_oldest = min(os.stat(f).st_mtime
                                        for f in cythonized_files)
            except OSError:
                print >>sys.stderr, \
                    "Error: Cython-generated file {0} is missing.".format(f)
                if cythonize:
                    print >>sys.stderr, "Install Cython so it can be made" \
                    " or use a source distribution of kwant."
                else:
                    print >>sys.stderr, "Run setup.py without", \
                        NO_CYTHON_OPTION
247
                exit(1)
Christoph Groth's avatar
Christoph Groth committed
248
249
250
251
252
253
254
255
256
257
258
259
260
261
262
263
264
265
266
            for f in pyx_files + kwrds.get('depends', []):
                if os.stat(f).st_mtime > cythonized_oldest:
                    msg = "Warning: {0} is newer than its source file, "
                    if cythonize:
                        msg += "but Cython is not installed."
                    else:
                        msg += "but Cython is not to be run."
                    print >>sys.stderr, msg.format(f)

        result.append(Extension(*args, **kwrds))

    return result


def main():
    if cythonize and cython_version < REQUIRED_CYTHON_VERSION:
        msg = 'Warning: Cython {0} is required but '
        if cython_version:
            msg += 'only {1} is present.'
267
        else:
Christoph Groth's avatar
Christoph Groth committed
268
269
270
271
            msg += 'it is not installed.'
        print >>sys.stderr, msg.format(
            '.'.join(str(e) for e in REQUIRED_CYTHON_VERSION),
            '.'.join(str(e) for e in cython_version))
272

Christoph Groth's avatar
Christoph Groth committed
273
274
275
276
277
278
279
280
281
282
283
284
    setup(name='kwant',
          version=version(),
          author='A. R. Akhmerov, C. W. Groth, X. Waintal, M. Wimmer',
          author_email='christoph.groth@cea.fr',
          description="A package for numerical "
          "quantum transport calculations.",
          license="not to be distributed",
          packages=["kwant", "kwant.graph", "kwant.linalg", "kwant.physics",
                    "kwant.solvers"],
          cmdclass={'build_ext': kwant_build_ext},
          ext_modules=ext_modules(extensions()),
          include_dirs=[numpy.get_include()])
285

Christoph Groth's avatar
Christoph Groth committed
286
287
if __name__ == '__main__':
    main()